Bug 10482 - Backward-incompatible changes to TERMTYPE cause core dumps
Backward-incompatible changes to TERMTYPE cause core dumps
Status: CLOSED RAWHIDE
Product: Red Hat Linux
Classification: Retired
Component: ncurses (Show other bugs)
6.2
All Linux
medium Severity high
: ---
: ---
Assigned To: Bernhard Rosenkraenzer
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2000-03-31 11:09 EST by vigna
Modified: 2008-05-01 11:37 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2000-04-07 16:01:07 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description vigna 2000-03-31 11:09:51 EST
ncurses 5.0 changed in a backward-incompatible way the TERMTYPE structure,
going from

typedef struct termtype {       /* in-core form of terminfo data */
    char  *term_names;          /* str_table offset of term names */
    char  *str_table;           /* pointer to string table */
    char  Booleans[BOOLCOUNT];  /* array of values */
    short Numbers[NUMCOUNT];    /* array of values */
    char  *Strings[STRCOUNT];   /* array of string offsets */
...

to

typedef struct termtype {       /* in-core form of terminfo data */
    char  *term_names;          /* str_table offset of term names */
    char  *str_table;           /* pointer to string table */
    char  *Booleans;            /* array of boolean values */
    short *Numbers;             /* array of integer values */
    char  **Strings;            /* array of string offsets */
...

The SYNTACTIC access to the structure is the same, thanks to the confusion
existing in C between an array and the pointer to its first element, but
the SEMANTICS is completely screwed up. All programs (such as ne, the nice
editor) accessing directly the capabilities strings in the terminfo
database will now need to be distributed in two distinct binary versions,
pre-5.0 and post-5.0.

To make things even worse, the package ncurses-5.0 installs a library
called libncurses.so.4.0, while the package ncurses-4.2 installs a library
called libncurses.so.4.2.
Comment 1 Martin Bly 2000-04-04 05:42:59 EDT
This has to be a slip-up by RedHat.   I would have expected the
ncurses-5.0 set to have libncurses.so.5 and kin, and for a
backwards compatability set with libncurses.so.4.2.

This problem has bitten us hard - we were about to go to
production with our latest software built under RH6.1 with the
expectation that it would work under 6.2.  Now we have to
stop and consider what to do.  A proper fix asap would be nice.
Comment 2 Bernhard Rosenkraenzer 2000-04-07 16:01:59 EDT
Rawhide has a libncurses.so.5

Note You need to log in before you can comment on or make changes to this bug.